/**
 * Copyright 2008-2012 Charles Amey
 * 
 * This file is part of Fuel Manager.
 * 
 * Fuel Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Fuel Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Fuel Manager.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <QtGui>
#include <QDebug>
#include "datedelegate.h"
#include "editdate.h"

//DateDelegate::DateDelegate(QList< QList<QVariant> > data, QObject *parent)
DateDelegate::DateDelegate(QObject *parent)
     : QItemDelegate(parent)

{
}

DateDelegate::~DateDelegate()
{
}

QWidget *DateDelegate::createEditor(QWidget *parent,
     const QStyleOptionViewItem &/* option */,
     const QModelIndex & /*index*/ ) const
{
     //qDebug()<<"createEditor function, before setModal";
     //t = new EditDate();
	EditDate *t = new EditDate();
	t->setModal(true);
	return t;
}//end createEditor

void DateDelegate::setEditorData(QWidget *editor,
                                    const QModelIndex &index) const
{
     QString value = index.model()->data(index, Qt::DisplayRole).toString();
     QDate thedate = QDate::fromString(value,"MMMM d, yyyy");
     EditDate *d = static_cast<EditDate*>(editor);
     d->setDate(thedate);
}

void DateDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                    const QModelIndex &index) const
{
     //qDebug("inside setModelData");
     if (index.isValid())
     {
	  EditDate *d = static_cast<EditDate *>(editor);
	  if (d->getChangeme() == 1)
	  {
	       //qDebug("change the date to this:");
	       //qDebug()<<d->getDate();
	       model->setData(index,d->getDate());
	  }
/*
No, no, no, don't do it this way,
more like this instead
[23:03] <ahigerd1> There's a "dirty" property and a dataChanged signal for that :P
[23:04] <kc8hfi> oh, I see.  So the setModelData of the delegate could emit the dataChanged signal, and I could have that button's slot hooked to it?
[23:04] <ahigerd1> The model itself emits it for you
[23:04] <ahigerd1> QAbstractItemModel::dataChanged(QModelIndex, QModelIndex)
[23:04] <ahigerd1> Connect to setEnabled()

*/
    //emit model->dataChanged(index,index);

  }//end index was valid
}//end setModelData

//void DateDelegate::updateEditorGeometry(QWidget *editor,
//     const QStyleOptionViewItem &option, const QModelIndex &/* index */) const
//{
     //qDebug("inside updateEditorGeometry");
     //editor->setGeometry(option.rect);
//}
 
